import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
var _excluded = ["blob", "croppedBase64", "url", "hasErrors", "id"];

function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return exports; }; var exports = {}, Op = Object.prototype, hasOwn = Op.hasOwnProperty, $Symbol = "function" == typeof Symbol ? Symbol : {}, iteratorSymbol = $Symbol.iterator || "@@iterator", asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator", toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag"; function define(obj, key, value) { return Object.defineProperty(obj, key, { value: value, enumerable: !0, configurable: !0, writable: !0 }), obj[key]; } try { define({}, ""); } catch (err) { define = function define(obj, key, value) { return obj[key] = value; }; } function wrap(innerFn, outerFn, self, tryLocsList) { var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator, generator = Object.create(protoGenerator.prototype), context = new Context(tryLocsList || []); return generator._invoke = function (innerFn, self, context) { var state = "suspendedStart"; return function (method, arg) { if ("executing" === state) throw new Error("Generator is already running"); if ("completed" === state) { if ("throw" === method) throw arg; return doneResult(); } for (context.method = method, context.arg = arg;;) { var delegate = context.delegate; if (delegate) { var delegateResult = maybeInvokeDelegate(delegate, context); if (delegateResult) { if (delegateResult === ContinueSentinel) continue; return delegateResult; } } if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) { if ("suspendedStart" === state) throw state = "completed", context.arg; context.dispatchException(context.arg); } else "return" === context.method && context.abrupt("return", context.arg); state = "executing"; var record = tryCatch(innerFn, self, context); if ("normal" === record.type) { if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue; return { value: record.arg, done: context.done }; } "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg); } }; }(innerFn, self, context), generator; } function tryCatch(fn, obj, arg) { try { return { type: "normal", arg: fn.call(obj, arg) }; } catch (err) { return { type: "throw", arg: err }; } } exports.wrap = wrap; var ContinueSentinel = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var IteratorPrototype = {}; define(IteratorPrototype, iteratorSymbol, function () { return this; }); var getProto = Object.getPrototypeOf, NativeIteratorPrototype = getProto && getProto(getProto(values([]))); NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype); var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype); function defineIteratorMethods(prototype) { ["next", "throw", "return"].forEach(function (method) { define(prototype, method, function (arg) { return this._invoke(method, arg); }); }); } function AsyncIterator(generator, PromiseImpl) { function invoke(method, arg, resolve, reject) { var record = tryCatch(generator[method], generator, arg); if ("throw" !== record.type) { var result = record.arg, value = result.value; return value && "object" == typeof value && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) { invoke("next", value, resolve, reject); }, function (err) { invoke("throw", err, resolve, reject); }) : PromiseImpl.resolve(value).then(function (unwrapped) { result.value = unwrapped, resolve(result); }, function (error) { return invoke("throw", error, resolve, reject); }); } reject(record.arg); } var previousPromise; this._invoke = function (method, arg) { function callInvokeWithMethodAndArg() { return new PromiseImpl(function (resolve, reject) { invoke(method, arg, resolve, reject); }); } return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); }; } function maybeInvokeDelegate(delegate, context) { var method = delegate.iterator[context.method]; if (undefined === method) { if (context.delegate = null, "throw" === context.method) { if (delegate.iterator["return"] && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method)) return ContinueSentinel; context.method = "throw", context.arg = new TypeError("The iterator does not provide a 'throw' method"); } return ContinueSentinel; } var record = tryCatch(method, delegate.iterator, context.arg); if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel; var info = record.arg; return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel); } function pushTryEntry(locs) { var entry = { tryLoc: locs[0] }; 1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry); } function resetTryEntry(entry) { var record = entry.completion || {}; record.type = "normal", delete record.arg, entry.completion = record; } function Context(tryLocsList) { this.tryEntries = [{ tryLoc: "root" }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0); } function values(iterable) { if (iterable) { var iteratorMethod = iterable[iteratorSymbol]; if (iteratorMethod) return iteratorMethod.call(iterable); if ("function" == typeof iterable.next) return iterable; if (!isNaN(iterable.length)) { var i = -1, next = function next() { for (; ++i < iterable.length;) { if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next; } return next.value = undefined, next.done = !0, next; }; return next.next = next; } } return { next: doneResult }; } function doneResult() { return { value: undefined, done: !0 }; } return GeneratorFunction.prototype = GeneratorFunctionPrototype, define(Gp, "constructor", GeneratorFunctionPrototype), define(GeneratorFunctionPrototype, "constructor", GeneratorFunction), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) { var ctor = "function" == typeof genFun && genFun.constructor; return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name)); }, exports.mark = function (genFun) { return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun; }, exports.awrap = function (arg) { return { __await: arg }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () { return this; }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) { void 0 === PromiseImpl && (PromiseImpl = Promise); var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl); return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) { return result.done ? result.value : iter.next(); }); }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () { return this; }), define(Gp, "toString", function () { return "[object Generator]"; }), exports.keys = function (object) { var keys = []; for (var key in object) { keys.push(key); } return keys.reverse(), function next() { for (; keys.length;) { var key = keys.pop(); if (key in object) return next.value = key, next.done = !1, next; } return next.done = !0, next; }; }, exports.values = values, Context.prototype = { constructor: Context, reset: function reset(skipTempReset) { if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) { "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined); } }, stop: function stop() { this.done = !0; var rootRecord = this.tryEntries[0].completion; if ("throw" === rootRecord.type) throw rootRecord.arg; return this.rval; }, dispatchException: function dispatchException(exception) { if (this.done) throw exception; var context = this; function handle(loc, caught) { return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught; } for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i], record = entry.completion; if ("root" === entry.tryLoc) return handle("end"); if (entry.tryLoc <= this.prev) { var hasCatch = hasOwn.call(entry, "catchLoc"), hasFinally = hasOwn.call(entry, "finallyLoc"); if (hasCatch && hasFinally) { if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0); if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc); } else if (hasCatch) { if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0); } else { if (!hasFinally) throw new Error("try statement without catch or finally"); if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc); } } } }, abrupt: function abrupt(type, arg) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) { var finallyEntry = entry; break; } } finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null); var record = finallyEntry ? finallyEntry.completion : {}; return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record); }, complete: function complete(record, afterLoc) { if ("throw" === record.type) throw record.arg; return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel; }, finish: function finish(finallyLoc) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel; } }, "catch": function _catch(tryLoc) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.tryLoc === tryLoc) { var record = entry.completion; if ("throw" === record.type) { var thrown = record.arg; resetTryEntry(entry); } return thrown; } } throw new Error("illegal catch attempt"); }, delegateYield: function delegateYield(iterable, resultName, nextLoc) { return this.delegate = { iterator: values(iterable), resultName: resultName, nextLoc: nextLoc }, "next" === this.method && (this.arg = undefined), ContinueSentinel; } }, exports; }

import { formatToBase64 } from './photoTools.js';
import { ACTIONS, DEFAULT_HAS_ERRORS_STATUS, DEFAULT_IMAGE_ROTATION_DEGREES, REJECT_FILES_REASONS } from './config.js';
export var filterValidFiles = function filterValidFiles(_ref) {
  var files = _ref.files,
      filesToBeFiltered = _ref.filesToBeFiltered,
      acceptedFileMaxSize = _ref.acceptedFileMaxSize,
      handlePhotosRejected = _ref.handlePhotosRejected,
      setMaxSizeError = _ref.setMaxSizeError,
      setMaxPhotosError = _ref.setMaxPhotosError,
      allowUploadDuplicatedPhotos = _ref.allowUploadDuplicatedPhotos,
      maxPhotos = _ref.maxPhotos;
  var notExcedingMaxSizeFiles = [];
  var excedingMaxSizeFiles = [];

  var notExcedingMaxSizeFilesFilter = function notExcedingMaxSizeFilesFilter(filesToFilter) {
    return filesToFilter.forEach(function (fileToFilter) {
      if (fileToFilter.size >= acceptedFileMaxSize) {
        excedingMaxSizeFiles.push({
          rejectedFile: fileToFilter,
          reason: "" + REJECT_FILES_REASONS.maxSize + acceptedFileMaxSize
        });
      } else {
        notExcedingMaxSizeFiles.push(fileToFilter);
      }
    });
  };

  var notRepeatedFiles = [];
  var repeatedFiles = [];

  var notRepeatedFilesFilter = function notRepeatedFilesFilter(filesToFilter) {
    return filesToFilter.forEach(function (fileToFilter) {
      var newFilePath = fileToFilter.path,
          newFileSize = fileToFilter.size,
          newFileLastModified = fileToFilter.lastModified;
      var isFileAlready = files.some(function (file) {
        var url = file.url,
            properties = file.properties;
        if (url) return false;
        var path = properties.path,
            size = properties.size,
            lastModified = properties.lastModified;
        return path === newFilePath && size === newFileSize && lastModified === newFileLastModified;
      });

      if (isFileAlready) {
        repeatedFiles.push({
          rejectedFile: fileToFilter,
          reason: REJECT_FILES_REASONS.repeated
        });
      } else {
        notRepeatedFiles.push(fileToFilter);
      }
    });
  };

  notExcedingMaxSizeFilesFilter(filesToBeFiltered);

  if (excedingMaxSizeFiles.length) {
    setMaxSizeError();
    handlePhotosRejected(excedingMaxSizeFiles);
  }

  if (allowUploadDuplicatedPhotos) {
    notRepeatedFiles.push.apply(notRepeatedFiles, notExcedingMaxSizeFiles);
  } else {
    notRepeatedFilesFilter(notExcedingMaxSizeFiles);
  }

  if (repeatedFiles.length) {
    handlePhotosRejected(repeatedFiles);
  }

  if (!notRepeatedFiles.length) return notRepeatedFiles;

  if (files.length + notRepeatedFiles.length >= maxPhotos) {
    setMaxPhotosError();
    var howManyFilesToMax = maxPhotos - files.length;
    notRepeatedFiles.splice(howManyFilesToMax - 1, notRepeatedFiles.length - howManyFilesToMax);
  }

  return notRepeatedFiles;
};
export function callbackUploadPhotoHandler(_x, _x2, _x3) {
  return _callbackUploadPhotoHandler.apply(this, arguments);
}

function _callbackUploadPhotoHandler() {
  _callbackUploadPhotoHandler = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(blob, callbackUploadPhoto, oldUrl) {
    var response;
    return _regeneratorRuntime().wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            if (!callbackUploadPhoto) {
              _context3.next = 10;
              break;
            }

            _context3.prev = 1;
            _context3.next = 4;
            return callbackUploadPhoto(blob, oldUrl);

          case 4:
            response = _context3.sent;
            return _context3.abrupt("return", response.url);

          case 8:
            _context3.prev = 8;
            _context3.t0 = _context3["catch"](1);

          case 10:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, null, [[1, 8]]);
  }));
  return _callbackUploadPhotoHandler.apply(this, arguments);
}

export var prepareFiles = function prepareFiles(_ref2) {
  var callbackUploadPhoto = _ref2.callbackUploadPhoto,
      currentFiles = _ref2.currentFiles,
      defaultFormatToBase64Options = _ref2.defaultFormatToBase64Options,
      errorCorruptedPhotoUploadedText = _ref2.errorCorruptedPhotoUploadedText,
      errorSaveImageEndpoint = _ref2.errorSaveImageEndpoint,
      handlePhotosRejected = _ref2.handlePhotosRejected,
      newFiles = _ref2.newFiles,
      setCorruptedFileError = _ref2.setCorruptedFileError,
      setFiles = _ref2.setFiles,
      setIsLoading = _ref2.setIsLoading,
      _scrollToBottom = _ref2._scrollToBottom,
      _callbackPhotosUploaded = _ref2._callbackPhotosUploaded;
  newFiles.reduce(function (accumulatorPromise, nextFile, index) {
    return accumulatorPromise.then(function () {
      return formatToBase64({
        file: nextFile,
        options: defaultFormatToBase64Options
      });
    }).then( /*#__PURE__*/function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(_ref3) {
        var file, blob, originalBase64, croppedBase64, rotation, _ref3$hasErrors, hasErrors, errorText, url;

        return _regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                file = _ref3.file, blob = _ref3.blob, originalBase64 = _ref3.originalBase64, croppedBase64 = _ref3.croppedBase64, rotation = _ref3.rotation, _ref3$hasErrors = _ref3.hasErrors, hasErrors = _ref3$hasErrors === void 0 ? DEFAULT_HAS_ERRORS_STATUS : _ref3$hasErrors;

                if (!hasErrors) {
                  _context.next = 7;
                  break;
                }

                errorText = errorCorruptedPhotoUploadedText.replace('%{filepath}', nextFile.path);
                handlePhotosRejected([{
                  rejectedFile: nextFile,
                  reason: REJECT_FILES_REASONS.loadFailed
                }]);
                setCorruptedFileError(errorText);
                _context.next = 11;
                break;

              case 7:
                _context.next = 9;
                return callbackUploadPhotoHandler(blob, callbackUploadPhoto);

              case 9:
                url = _context.sent;

                if (errorSaveImageEndpoint && !url) {
                  setCorruptedFileError(errorSaveImageEndpoint);
                } else {
                  currentFiles.push({
                    blob: blob,
                    file: file,
                    hasErrors: hasErrors,
                    isModified: false,
                    isNew: true,
                    originalBase64: originalBase64,
                    properties: {
                      path: nextFile.path,
                      size: nextFile.size,
                      lastModified: nextFile.lastModified
                    },
                    preview: croppedBase64,
                    rotation: rotation,
                    url: url
                  });
                }

              case 11:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x4) {
        return _ref4.apply(this, arguments);
      };
    }()).then(function () {
      setFiles([].concat(currentFiles));

      if (index >= newFiles.length - 1) {
        setIsLoading(false);

        _scrollToBottom();

        _callbackPhotosUploaded(currentFiles, {
          action: ACTIONS.UPLOAD
        });
      }
    });
  }, Promise.resolve());
};
export var loadInitialPhotos = /*#__PURE__*/function () {
  var _ref6 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(_ref5) {
    var initialPhotos, defaultFormatToBase64Options, setInitialDownloadError, setFiles, _callbackPhotosUploaded, setIsLoading, filesWithBase64, newFiles, readyPhotos;

    return _regeneratorRuntime().wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            initialPhotos = _ref5.initialPhotos, defaultFormatToBase64Options = _ref5.defaultFormatToBase64Options, setInitialDownloadError = _ref5.setInitialDownloadError, setFiles = _ref5.setFiles, _callbackPhotosUploaded = _ref5._callbackPhotosUploaded, setIsLoading = _ref5.setIsLoading;
            filesWithBase64 = initialPhotos.map(function (item) {
              return formatToBase64({
                item: item,
                options: defaultFormatToBase64Options
              });
            });
            _context2.next = 4;
            return Promise.all(filesWithBase64);

          case 4:
            newFiles = _context2.sent;
            readyPhotos = newFiles.map(function (_ref7) {
              var blob = _ref7.blob,
                  croppedBase64 = _ref7.croppedBase64,
                  url = _ref7.url,
                  _ref7$hasErrors = _ref7.hasErrors,
                  hasErrors = _ref7$hasErrors === void 0 ? DEFAULT_HAS_ERRORS_STATUS : _ref7$hasErrors,
                  id = _ref7.id,
                  rest = _objectWithoutPropertiesLoose(_ref7, _excluded);

              return _extends({
                blob: blob,
                url: url,
                hasErrors: hasErrors,
                originalBase64: croppedBase64,
                preview: croppedBase64,
                rotation: DEFAULT_IMAGE_ROTATION_DEGREES,
                isNew: false,
                isModified: false,
                id: id
              }, rest);
            });

            if (readyPhotos.some(function (photos) {
              return photos.hasErrors;
            })) {
              setInitialDownloadError();
            }

            setFiles([].concat(readyPhotos));

            _callbackPhotosUploaded(readyPhotos, {
              action: ACTIONS.INITIAL_LOAD
            });

            setIsLoading(false);

          case 10:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function loadInitialPhotos(_x5) {
    return _ref6.apply(this, arguments);
  };
}();